-- MySQL dump 10.11
--
-- Host: localhost    Database: nspslalog
-- ------------------------------------------------------
-- Server version	5.0.45

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


SET FOREIGN_KEY_CHECKS = 0;

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `nspslalog` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `nspslalog`;

--
-- Table structure for table `LogPoint`
--

DROP TABLE IF EXISTS `LogPoint`;
CREATE TABLE `LogPoint` (
  `idLogPoint` bigint(20) NOT NULL auto_increment,
  `logPointName` varchar(64) NOT NULL,
  `logPointUniqueId` varchar(36) NOT NULL,
  `createdTime` timestamp NOT NULL default '0000-00-00 00:00:00',
  `createdByHost` varchar(64) NOT NULL,
  `createdByApplication` varchar(36) NOT NULL,
  PRIMARY KEY  (`idLogPoint`),
  UNIQUE KEY `ix1` (`logPointUniqueId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `SOAPCallInfo`
--

DROP TABLE IF EXISTS `SOAPCallInfo`;
CREATE TABLE `SOAPCallInfo` (
  `idSOAPCallInfo` bigint(20) NOT NULL auto_increment,
  `sourceSOAPOp` varchar(64) NOT NULL,
  `sourceSOAPEndPoint` varchar(256) NOT NULL,
  `sourceSOAPAction` varchar(320) NOT NULL,
  `targetSOAPOp` varchar(64) NOT NULL,
  `targetSOAPEndPoint` varchar(256) NOT NULL,
  `createdTime` timestamp NOT NULL default '0000-00-00 00:00:00',
  `createdByHost` varchar(64) NOT NULL,
  `createdByApplication` varchar(36) NOT NULL,
  PRIMARY KEY  (`idSOAPCallInfo`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `LogRecord`
--

DROP TABLE IF EXISTS `LogRecord`;
CREATE TABLE `LogRecord` (
  `idLogRecord` bigint(20) NOT NULL auto_increment,
  `idLogPoint` bigint(20) NOT NULL,
  `idSOAPCallInfo` bigint(20) NOT NULL,
  `timestampStartMillis` bigint(20) NOT NULL,
  `timestampEndMillis` bigint(20) NOT NULL,
  `timeStartNanos` bigint(20) NOT NULL,
  `timeEndNanos` bigint(20) NOT NULL,
  `messageId` varchar(36) NOT NULL,
  `requestSize` bigint(20) NOT NULL default '0',
  `replySize` bigint(20) NOT NULL default '0',
  `requestStatus` int(4) NOT NULL default '0',
  `createdTime` timestamp NOT NULL default '0000-00-00 00:00:00',
  `createdByHost` varchar(64) NOT NULL,
  `createdByApplication` varchar(36) NOT NULL,
  PRIMARY KEY  (`idLogRecord`),
  KEY `LogRecord_fk1` (`idLogPoint`),
  KEY `LogRecord_fk2` (`idSOAPCallInfo`),
  CONSTRAINT `LogRecord_fk1` FOREIGN KEY (`idLogPoint`) REFERENCES `LogPoint` (`idLogPoint`) ON DELETE CASCADE,
  CONSTRAINT `LogRecord_fk2` FOREIGN KEY (`idSOAPCallInfo`) REFERENCES `SOAPCallInfo` (`idSOAPCallInfo`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `LogRecordRequestParam`
--

DROP TABLE IF EXISTS `LogRecordRequestParam`;
CREATE TABLE `LogRecordRequestParam` (
  `idLogRecordRequestParam` bigint(20) NOT NULL auto_increment,
  `idLogRecord` bigint(20) NOT NULL,
  `paramKey` varchar(32) NOT NULL,
  `paramValue` varchar(256) NOT NULL,
  `createdTime` timestamp NOT NULL default '0000-00-00 00:00:00',
  `createdByHost` varchar(64) NOT NULL,
  `createdByApplication` varchar(36) NOT NULL,
  PRIMARY KEY  (`idLogRecordRequestParam`),
  KEY `LogRecordRequestParam_fk1` (`idLogRecord`),
  CONSTRAINT `LogRecordRequestParam_fk1` FOREIGN KEY (`idLogRecord`) REFERENCES `LogRecord` (`idLogRecord`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

SET FOREIGN_KEY_CHECKS = 1;

/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-04-28 13:06:16
