#! /bin/bash

process() {
  filename=$1
  keep_length=$2
  chop_end='35000'

  base=`dirname ${filename}`/`basename ${filename} .jtl`
  input="${base}.jtl"
  output="${base}-processed.jtl"
  if [ "${input}" -nt "${output}" ]; then

    #start=`xmlstarlet sel -t -v '/testResults/sample[1]/@ts' $input`
    end=`xmlstarlet sel -t -v 'math:max(/testResults/sample/@ts)' $input`
    # Remove unwanted segments:
    xmlstarlet ed \
       -d "/testResults/sample[@ts<(${end}-${keep_length}-${chop_end})]" \
       -d "/testResults/sample[@ts>(${end}-${chop_end})]" \
       $input > $output
    # Make a sorted-by-sample-value version for median, etc:
    xmlstarlet sel -t -e testResults -m /testResults/sample -s A:N:- '@t' -c . $output \
    | \
    xmlstarlet tr `dirname $0`/percentiles.xlst -s inputFile="$base"
  fi
}

echo "filename,TPH,average,median,p90,p95,p98,p99,maximum,transactions,successes"
for filename in `ls scripted-*.jtl|grep -v processed`; do
  process ${filename} '180000'
done


exit 0
########## Experiment notes:

# xmlstarlet sel -t -m /testResults/sample -s A:N:- '@t' -t -v 'floor(count(/testResults/sample)*0.95)' test.xml

# xmlstarlet sel -t -v '/sample[floor(count(/sample)*0.90)]/@t'

# xmlstarlet sel -t -e testResults -m /testResults/sample -s A:N:- '@t' -c . test.xml  | xmlstarlet sel -t -v '/testResults/sample[floor(count(/testResults/sample)*0.90)]/@t'

  xmlstarlet sel -C \
  -t -f  \
  -t -v '/testResults/sample[1]/@t' -o , \
  -t -v '/testResults/sample[floor($sampleCount*0.50)]/@t' -o , \
  -t -v '/testResults/sample[floor($sampleCount*0.90)]/@t' -o , \
  -t -v '/testResults/sample[floor($sampleCount*0.95)]/@t' -o , \
  -t -v '/testResults/sample[floor($sampleCount*0.98)]/@t' -o , \
  -t -v '/testResults/sample[floor($sampleCount*0.99)]/@t' -o , \
  -t -v '/testResults/sample[last()]/@t'
