#!/bin/bash

if [ ! -f applet.jks ]; then
  rm -f applet.jks applet.csr

  keytool -genkey -alias applet  -keyalg RSA -keysize 1024 -keystore applet.jks -storepass changeit -keypass changeit -dname "CN=Applet, OU=Trifork A/S, O=Trifork A/S, L=Aarhus, S=Denmark, C=DK"

  keytool -certreq -alias applet -keystore applet.jks -storepass changeit -keypass changeit -file applet.csr

  openssl ca -in applet.csr -out applet.csr.pem -keyfile ca.key -key changeit

  openssl x509 -in applet.csr.pem -out applet.csr.der -outform DER 

  keytool -import -keystore applet.jks -alias applet_key -file applet.csr.der -trustcacerts -storepass changeit -keypass changeit
fi

jarsigner -verbose -keystore ./applet.jks sign/OpenSign-bootstrapped.jar applet

echo "you must also have imported the ca into your JDK."
echo "sudo keytool -import -keystore /products/jdk-1.5.0/jre/lib/security/cacerts -alias mortens_ca -file ca.crt"

