/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.api;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public abstract class Constants {
    // DGWS 1.0 implied constants 
    public static final long MAX_IDCARD_LIFETIME_HOURS = 24;

    // Namespaces
    public static final String HTTP_SOSI_DK_GW_2007_09_01 = "http://sosi.dk/gw/2007.09.01";
    public static final String URN_SAML_2_0_ASSERTION = "urn:oasis:names:tc:SAML:2.0:assertion";
    public static final String URN_WS_ADDRESSING_2004_08 = "http://schemas.xmlsoap.org/ws/2004/08/addressing";
    public static final String URN_WS_ADDRESSING_1_0 = "http://www.w3.org/2005/08/addressing";
    public static final String URL_SOAP = "http://schemas.xmlsoap.org/soap/envelope/";
    public static final String URL_MEDCOM = "http://www.medcom.dk/dgws/2006/04/dgws-1.0.xsd";
    public static final String HTTP_WWW_W3_ORG_2000_09_XMLDSIG = "http://www.w3.org/2000/09/xmldsig#";
    public static final String URL_WSSE = "http://docs.oasisopen.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd";
    public static final String URL_WSU = "http://docs.oasisopen.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd";
    
    // Tag names
    public static final String SOAP_ENVELOPE = "Envelope";
    public static final String SOAP_HEADER = "Header";
    public static final String REQUEST_ID_CARD_DIGEST_FOR_SIGNING_RESPONSE = "requestIdCardDigestForSigningResponse";
    public static final String BROWSER_URL = "browserUrl";
    public static final String DIGEST_VALUE = "DigestValue";
    public static final String REQUEST_PRIORITY = "RequestPriority";
    public static final String MAX_AGE = "MaxAge";
    public static final String CLIENT_ACCESS_KEY = "ClientAccessKey";
    public static final String PASS_THROUGH = "PassThrough";

    // Misc
    public static final String SOSIGW_IT_SYSTEM_PRODUCTION_NAME = "SOSIGW";
    public static final String SOSIGW_IT_SYSTEM_TESTNAME = "SOSITEST";
    public static final String SOAP_ACTION_HEADER = "SOAPAction";
    public static final String XML_VERSION_1_0_ENCODING_UTF_8 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    public static final String UTF_8 = "UTF-8";
    public static final String MISSING_USER_IDCARD_IN_REQUEST_MSG = "Missing UserIDCard in request";
    public static final String HTTPHEADER_TEXT_XML_CHARSET_UTF_8 = "text/xml; charset=utf-8";
	public static final String HTTPHEADER_NAME_NSI_ORIGINAL_CLIENT_IP = "X-NSI-Original-Client-IP";

	// Console stuff
    public static final String BROWSER_CONSOLECOOKIE = "sosigwconsole";
    public static final String CONSOLE_LOGIN_DONE_PAGE_URL = "/com.trifork.sosigw.console.ConsoleApp/ConsoleApp.html";

    // Fault codes for DGWSFault.
    public static final String FAULTCODE_MISSING_USER_IDCARD_IN_REQUEST = "sosigw_no_valid_idcard_in_request";
    public static final String FAULTCODE_MISSING_SIGNINGINFO_IN_REQUEST = "sosigw_missing_signinginfo_in_request";
    public static final String FAULTCODE_AWAITING_SIGNING = "sosigw_awaiting_signing";
    public static final String FAULTCODE_INTERNAL_ERROR = "sosigw_internal_error";
    public static final String FAULTCODE_PROXY_ERROR = "sosigw_proxy_error";
    public static final String FAULTCODE_NO_VALID_IDCARD_IN_CACHE = "sosigw_no_valid_idcard_in_cache";
    public static final String FAULTCODE_SYNTAX_ERROR = "sosigw_syntax_error_in_request";
    public static final String FAULTCODE_ACCESS_DENIED = "sosigw_access_denied";

}
