/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.auditlog;

import org.apache.log4j.Logger;

import com.trifork.sosigw.Factory;
import com.trifork.sosigw.api.IDCardCache;

/**
 * Logs auditlog items to log4j in a splunk friendly format
 * 
 * @author Morten Grouleff <mgr@trifork.com>
 *
 */
public class Audit2Log4j implements AuditLogger {
    private static final Logger log = Logger.getLogger(Audit2Log4j.class); 
    
     public void log(AuditLogItem item) throws Exception {
        IDCardCache idCardCache = Factory.getIDCardCache();
        log.info("msg=IDCard." + item.operation + ", ip=" + item.clientIP + ", cpr=" + item.cpr + ", to=" + item.wsaTo + ", action=" + item.wsaAction + ", cache.size=" + idCardCache.size() + ", cache.hash=" + idCardCache.contentHash());
    }
}
