/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.cluster;

import javax.management.NotificationBroadcasterSupport;

import com.trifork.sosigw.Factory;
import com.trifork.sosigw.api.IDCardCache;
import com.trifork.sosigw.api.IDCardClusterCache;

public class ManageIDCardClusterCache extends NotificationBroadcasterSupport implements ManageIDCardClusterCacheMBean {

    @Override
    public long getSize() {
        return Factory.getIDCardCache().size();
    }

    @Override
    public long getContentHash() {
        return Factory.getIDCardCache().contentHash();
    }

    @Override
    public long getArrivedFromPeer() {
        IDCardCache idCardCache = Factory.getIDCardCache();
        if (idCardCache instanceof IDCardClusterCache) {
            IDCardClusterCache idCardClusterCache = (IDCardClusterCache)idCardCache;
            return idCardClusterCache.getArrivedFromPeer();
        }
        return 0;
    }

    @Override
    public long getAddedFromPeer() {
        IDCardCache idCardCache = Factory.getIDCardCache();
        if (idCardCache instanceof IDCardClusterCache) {
            IDCardClusterCache idCardClusterCache = (IDCardClusterCache)idCardCache;
            return idCardClusterCache.getAddedFromPeer();
        }
        return 0;
    }

    @Override
    public long getReplacedFromPeer() {
        IDCardCache idCardCache = Factory.getIDCardCache();
        if (idCardCache instanceof IDCardClusterCache) {
            IDCardClusterCache idCardClusterCache = (IDCardClusterCache)idCardCache;
            return idCardClusterCache.getReplacedFromPeer();
        }
        return 0;
    }

    @Override
    public long getIgnoredFromPeer() {
        IDCardCache idCardCache = Factory.getIDCardCache();
        if (idCardCache instanceof IDCardClusterCache) {
            IDCardClusterCache idCardClusterCache = (IDCardClusterCache)idCardCache;
            return idCardClusterCache.getIgnoredFromPeer();
        }
        return 0;
    }

}

