/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.cluster.intercom;

import com.trifork.sosigw.config.StaticConfigApi;
import com.trifork.sosigw.config.StaticConfigImpl;


class TimeState {
    private static final StaticConfigApi STATIC_CONF = StaticConfigImpl.getInstance();

    private static final int MAXIMUM_SAMPLE_WIDTH = STATIC_CONF.getClusterTuningParam("timestate.samplewindow", 15);
    private int maximum = Integer.MIN_VALUE;
    private int maximumCnt = 0;
    
    private int curOffset;
    private boolean hasState;
    
    public void addSample(int offset) {
        if (maximum < offset) {
            maximum = offset;
        }
        if (++maximumCnt >= MAXIMUM_SAMPLE_WIDTH) {
            curOffset = maximum;
            maximum = Integer.MIN_VALUE;
            maximumCnt = 0;
            hasState = true;
        }
    }
    
    public int getCurOffset() {
        return curOffset;
    }
    
    public boolean getHasState() {
        return hasState;
    }
}
