/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.config;


/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public class RuntimeConfigMapperHsqldb extends RuntimeConfigMapperAbstractDb {


    protected String getDataInsertSql() {
        return "INSERT INTO " + SOSIGWLOG_RUNTIMECONFIG_DATA + " VALUES(NEXTVAL('" + SOSIGWLOG_RUNTIMECONFIG_PKSEQ + "'), ?, ?, ?)";
    }


    protected String getElmSelectSql() {
        return "SELECT elmpk FROM " + SOSIGWLOG_RUNTIMECONFIG_ELM + " WHERE configpk=? and category=? and elmkey=?";
    }


    protected String getElmInsertSql() {
        return "INSERT INTO " + SOSIGWLOG_RUNTIMECONFIG_ELM + " VALUES(NEXTVAL('" + SOSIGWLOG_RUNTIMECONFIG_PKSEQ + "'), ?, ?, ?, ?)";
    }


    protected String getTopSelectSql() {
        return "SELECT configpk FROM " + SOSIGWLOG_RUNTIMECONFIG + " WHERE moment=?";
    }


    protected String getTopInsertSql() {
        return "INSERT INTO " + SOSIGWLOG_RUNTIMECONFIG + " VALUES(NEXTVAL('" + SOSIGWLOG_RUNTIMECONFIG_PKSEQ + "'), ?)";
    }
}
