/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.config;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Properties;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public interface StaticConfigApi {
    boolean isBootstrapRestrictedMode();
    boolean isDeveloperRestrictedMode();
    String getClusterIpPrefix();
    int getMulticastPort();
    InetAddress getMulticastIpAddress() throws UnknownHostException;
    int getClusterTuningParam(String param, int def);
    boolean isProductionMode();
    String getSupportedDGWSVersion();
    boolean useLocalTimeInSaml();
    String getMode();
    boolean isKeepAliveEnabled();
    String getFMKIsAliveURL();
    String getCentralAuditLogTablePrefix();
    String getJdbcDriver();
    boolean isGlobalAuditLogEnabled();
    boolean isAuditLogToDbEnabled();
    String getDataSourceName();
    boolean isRestrictedWebserviceEnabled();
    String getConfigfilePath();

    boolean isTestMode();
    boolean isSLALogEnabled();

    RuntimeConfigStorageType getRuntimeconfigStorage();

    Properties getProperties();

    boolean isSTSMBeansEnabled();
}
