/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.client.panels;

import com.google.gwt.user.client.Window;
import com.trifork.sosigw.console.client.Context;
import com.trifork.sosigw.console.client.util.DefaultCallback;
import com.trifork.sosigw.console.client.widget.ResourceTable;
import com.trifork.sosigw.console.datamodel.ConfigCategory;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
///CLOVER:OFF
public class CategoryCreator extends AbstractResource implements ResourceFolder {

    private ResourceTable resTbl;
    private ConfigCategory category;

    public CategoryCreator(Context context, ConfigFolder parentFolder, String name, boolean b) {
        super(context, parentFolder, "", name, true, 2);

        category = new ConfigCategory();
    }

    protected void initSettingsTbl() {
        super.initSettingsTbl();

        resTbl = new ResourceTable(new String[] { "Name", "Description" }, "Configuration Fields", new ResourceTable.ResourceCreator() {

            public void newResource() {

                ColumnCreator column = new ColumnCreator(context, CategoryCreator.this, "New Configuration Field", true);
                column.setParentFolder(CategoryCreator.this);

                column.openInEditor();
            }
        });

        panel.add(resTbl);

    }
    
    protected void doCreate() {

        category.setName(nameField.getText());
        category.setDescription(descriptionField.getText());
        
        if (category.getColumns().length == 0) {
            Window.alert("Please specify one or more entry fields");
        } else {
            closeInEditor();
            
            context.getConsoleService().saveConfigCategory(category, new DefaultCallback() {

                public void onSuccess(Object result) {
                    CategoryFolder replacement = new CategoryFolder(context, resourceFolder, name, false);
                    replacement.addToNavTree();
                    replacement.openInEditor();
                }
            });
        }

    }

    public void doDelete() {
        // TODO Auto-generated method stub

    }

    protected void doSave() {
        // TODO Auto-generated method stub

    }

    public String[] getColumnText() {
        // TODO Auto-generated method stub
        return null;
    }

    protected void loadAndInit() {
        // TODO Auto-generated method stub

    }

    public void addResource(Resource resource) {
        // Resource must be a ColumnCreator

        category.addColumn(resource.getName());

        resTbl.addResource(resource);
    }

    public Resource createResource(Context context, String name, boolean b) {
        // TODO Auto-generated method stub
        return null;
    }

    public void removeResource(Resource resource) {
        resTbl.removeResource(resource);
    }

    public void removeSubNode(Resource resource) {
        // TODO Auto-generated method stub
        
    }

    public void updateResource(Resource resource) {
        // TODO Auto-generated method stub
        
    }

}
