/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.client.panels;

import com.google.gwt.user.client.Window;
import com.trifork.sosigw.console.client.Context;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
///CLOVER:OFF
public class ColumnCreator extends AbstractResource {

    private static final String CONFIGURATION_ENTRY_TYPE = "ConfigurationEntry";
    private final CategoryCreator categoryCreator;

    public ColumnCreator(Context context, CategoryCreator parentFolder, String name, boolean create) {

        super(context, parentFolder, CONFIGURATION_ENTRY_TYPE, name, create, 6);
        this.categoryCreator = parentFolder;
        
        icon = "images/icons/folder_database.png";
    }


    protected void loadAndInit() {
        // Already loaded with the ConfigCategory
    }

    public String[] getColumnText() {
        return new String[] { nameField.getText(), descriptionField.getText() };
    }

    protected void doSave() {
    }

    protected void doCreate() {

        name = nameField.getText();
        
        if (name.trim().length() == 0) {
            Window.alert("Please specify a column name");
        } else {
            categoryCreator.addResource(this);
            
            closeInEditor();
            resourceFolder.openInEditor();
        }
    }


    public void doDelete() {
    }

}
