/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.client.panels;

import java.util.ArrayList;
import java.util.Iterator;

import com.trifork.sosigw.console.client.Context;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
///CLOVER:OFF
public class DefaultFolder extends AbstractNode implements Folder {
    private static final String FOLDER_TYPE = "Folder";

    protected ArrayList subNodes = new ArrayList();
    
    public DefaultFolder(Context context, Folder parent, String name) {
        super(context, parent, FOLDER_TYPE, name);

        icon = "images/icons/folder.png";
    }

    protected void treeItemClicked() {
        // DefaultFolder has no editor
    }
    
    public void addToNavTree() {
        super.addToNavTree();
        
        Iterator i = subNodes.iterator();
        while (i.hasNext()) {
            ((AbstractNode)i.next()).addToNavTree();
        }
    }

    public void addSubNode(AbstractNode node) {
        subNodes.add(node);
        node.setParentFolder(this);
    }

    public void removeSubNode(Node node) {
        subNodes.remove(node);
        getTreeItem().removeItem(node.getTreeItem());
    }

    
}
