/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.datamodel;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public class AuditLogEntry implements IsSerializable {
    protected String cpr;
    protected long TimeStamp; // Ordinary java millis, UTC.
    protected String systemID;
    protected String clientIP;
    protected String wsaTo;
    protected String wsaAction;
    protected String operation; // Either "proxy" or IDCardState.toString.
    
    public String getCpr() {
        return cpr;
    }
    public void setCpr(String cpr) {
        this.cpr = cpr;
    }
    public long getTimeStamp() {
        return TimeStamp;
    }
    public void setTimeStamp(long timeStamp) {
        TimeStamp = timeStamp;
    }
    public String getSystemID() {
        return systemID;
    }
    public void setSystemID(String systemID) {
        this.systemID = systemID;
    }
    public String getClientIP() {
        return clientIP;
    }
    public void setClientIP(String clientIP) {
        this.clientIP = clientIP;
    }
    public String getWsaTo() {
        return wsaTo;
    }
    public void setWsaTo(String wsaTo) {
        this.wsaTo = wsaTo;
    }
    public String getWsaAction() {
        return wsaAction;
    }
    public void setWsaAction(String wsaAction) {
        this.wsaAction = wsaAction;
    }
    public String getOperation() {
        return operation;
    }
    public void setOperation(String operation) {
        this.operation = operation;
    }
}
