/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.datamodel;

import java.util.ArrayList;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public class ConfigCategory implements IsSerializable {

    /**
     * @gwt.typeArgs <com.trifork.sosigw.console.datamodel.ConfigItem>
     */
    protected ArrayList items = new ArrayList();
    protected String name;
    protected String description;
    protected String[] columns = new String[0];
    
    public ConfigCategory() {
    }
    
    public ConfigCategory(String name) {
        this.name = name;
    }
    
    public void addItem(ConfigItem item) {
        items.add(item);
    }

    public ConfigItem[] getConfigItems() {
        ConfigItem[] result = new ConfigItem[items.size()];
        items.toArray(result);
        return result;
    }

    public void removeItem(ConfigItem item) {
        items.remove(item);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setDescription(String description) {
        this.description = description;
    }
    
    public String getDescription() {
        return description;
    }

    public void setColumns(String[] columns) {
        this.columns = columns;
    }

    public String[] getColumns() {
        return columns;
    }

    public void addColumn(String name) {
        if (columns == null) {
            columns = new String[] { name };
        } else {
            String[] tmp = new String[columns.length + 1];
            for (int i = 0; i < columns.length; i++) {
                tmp[i] = columns[i];
            }
            
            tmp[columns.length] = name;
            columns = tmp;
        }
    }

}
