/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.datamodel;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public class IDCard implements IsSerializable {

    private String nameId;
    private String cpr;
    private String givenName;
    private String surName;
    private String email;
    private String occupation;
    private String role;
    private String authorizationCode;
    private String state;


    public IDCard() {
        
    }
    
    public IDCard(String nameId, String cpr, String givenName, String surName, String email, String occupation, String role, String authorizationCode) {
        this.nameId = nameId;
        this.cpr = cpr;
        this.givenName = givenName;
        this.surName = surName;
        this.email = email;
        this.occupation = occupation;
        this.role = role;
        this.authorizationCode = authorizationCode;
    }

    public String getNameId() {
        return nameId;
    }
    
    public String getAuthorizationCode() {
        return authorizationCode;
    }


    public String getCpr() {
        return cpr;
    }


    public String getEmail() {
        return email;
    }


    public String getGivenName() {
        return givenName;
    }


    public String getOccupation() {
        return occupation;
    }


    public String getRole() {
        return role;
    }


    public String getSurName() {
        return surName;
    }

    public void setState(String state) {
        this.state = state;
    }
    
    public String getState() {
        return state;
    }
}
