/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.console.service;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.RemoteService;
import com.trifork.sosigw.console.datamodel.AuditLogQuery;
import com.trifork.sosigw.console.datamodel.ConfigCategory;
import com.trifork.sosigw.console.datamodel.ConfigItem;
import com.trifork.sosigw.console.datamodel.IDCardQuery;

/**
 * 
 * 
 * @author Jeppe Sommer <jso at trifork.com>
 * @author Morten Grouleff <mgr at trifork.com>
 */
public interface ConsoleFacadeAsync extends RemoteService {
    void getConfigCategoryNames(AsyncCallback callback);
    void getConfigCategory(String categoryName, AsyncCallback callback);
    void saveConfigCategory(ConfigCategory category, AsyncCallback callback);
    void saveConfigItem(ConfigItem item, AsyncCallback callback);

    void removeConfigCategory(String categoryName, AsyncCallback callback);
    void removeConfigItem(String categoryName, String itemName, AsyncCallback callback);

    void searchIDCard(IDCardQuery query, AsyncCallback callback);

    void getIDCard(String name, AsyncCallback callback);

    void revokeIdCard(String nameId, AsyncCallback callback);

    void searchAuditLog(AuditLogQuery query, int offset, int count, AsyncCallback callback);
    
    void runtimeConfigIsInPropertiesMode(AsyncCallback callback);
}
