/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.util;

import com.sun.org.apache.xerces.internal.dom.DOMInputImpl;
import com.trifork.sosigw.api.Constants;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.ls.LSParser;

import javax.servlet.ServletException;
import java.io.IOException;

public class SoapHeader {

    public static Document getSoapEnvelopeNode(final StringBuffer soapHeader, final String soapNamespace)
            throws IOException, ServletException {
        soapHeader.append("</").append(soapNamespace).append(":" + Constants.SOAP_ENVELOPE + ">"); // Make the header
        // xml-balanced.
        final String balancedSoapHeader = soapHeader.toString();

        Document doc = parseSoapHeader(balancedSoapHeader);
        NodeList envelopeNodes = doc.getElementsByTagName(soapNamespace + ":" + Constants.SOAP_ENVELOPE);
        if (envelopeNodes.getLength() != 1) {
            throw new ServletException("Got " + envelopeNodes.getLength() + " soap-envelopes");
        }
        return doc;
    }

    protected static Document parseSoapHeader(final String balancedSoapHeader) throws ServletException {
        LSParser builder = DOMUtil.getDomLSParser();

        return builder.parse(new DOMInputImpl() {

            public String getStringData() {
                return balancedSoapHeader;
            }
        });
    }

}
