/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.ws;

import javax.jws.HandlerChain;
import javax.jws.WebService;

import org.oasis_open.docs.wss._2004._01.oasis_200401_wss_wssecurity_secext_1_0.Security;

import com.trifork.sosigw.api.Constants;
import com.trifork.sosigw.config.StaticConfigImpl;

import dk.sosi.gw._2007_09.DGWSFault;
import dk.sosi.gw._2007_09.RequestIdCardDigestForSigningResponse;
import dk.sosi.gw._2007_09.SignIdCardRequestBody;

/**
 * This class is handwritten to conform to the code generated by the JAX-WS RI.
 * 
 */
@WebService(endpointInterface = "dk.sosi.gw._2007_09.SosiGWRestrictedFacade")
@HandlerChain(file = "SosiGWFacade_handler.xml")
public class SosiGWRestrictedFacadeImpl implements dk.sosi.gw._2007_09.SosiGWRestrictedFacade {
    static dk.sosi.gw._2007_09.SosiGWFacade delegate = new SosiGWFacadeImpl();
    
    public RequestIdCardDigestForSigningResponse requestIdCardDigestForSigning(Security wsseHeader, String sosigwRequestIdCardDigestForSigningRequestBody) throws DGWSFault {
        if (enabled()) {
            return delegate.requestIdCardDigestForSigning(wsseHeader, sosigwRequestIdCardDigestForSigningRequestBody);
        } else {
            throw new DGWSFault("SOSIGW restricted webservice not enabled", Constants.FAULTCODE_INTERNAL_ERROR);
        }
    }

    public String signIdCard(Security wsseHeader, SignIdCardRequestBody sosigwSignIdCardRequestBody) throws DGWSFault {
        if (enabled()) {
            return delegate.signIdCard(wsseHeader, sosigwSignIdCardRequestBody);
        } else {
            throw new DGWSFault("SOSIGW restricted webservice not enabled", Constants.FAULTCODE_INTERNAL_ERROR);
        }
    }

    private boolean enabled() {
        return StaticConfigImpl.getInstance().isRestrictedWebserviceEnabled();
    }
}
