/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.auditlog;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;


public class SqlTestsUtil {
    public static void executeSql(DataSource ds, String sqlFile) throws SQLException, IOException {
        executeSql(ds, SqlTests.class, sqlFile);
    }
    
    public static void executeSql(DataSource ds, Class<?> loader, String sqlFile) throws SQLException, IOException {
        if(ds == null) {
            return;
        }
        
        try(Connection c = ds.getConnection()){
            final InputStream resourceAsStream = loader.getResourceAsStream(sqlFile);
            BufferedReader br = new BufferedReader(new InputStreamReader(resourceAsStream));
            String line = null;
            while ((line = br.readLine()) != null) {
                if (line.trim().equals("") || line.trim().startsWith("--"))
                    continue;

                c.prepareStatement(line.trim()).executeUpdate();
            }     
        }
    }
}
