/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.spikes;

import java.io.IOException;

import com.trifork.sosigw.cluster.IDCardClusterCacheImpl;
import com.trifork.sosigw.config.StaticConfigImpl;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.trifork.sosigw.Bootstrap;
import com.trifork.sosigw.Factory;
import com.trifork.sosigw.api.IDCardCache;
import com.trifork.sosigw.api.IDCardState;
import com.trifork.sosigw.cluster.IDCardClusterCacheEntry;

import dk.sosi.seal.model.AuthenticationLevel;
import dk.sosi.seal.model.CareProvider;
import dk.sosi.seal.model.SystemInfo;
import dk.sosi.seal.model.UserIDCard;
import dk.sosi.seal.model.UserInfo;

public class Cluster2Test {
    
    @Before
    public void setup() {
        Factory.setTheIDCardCache(new IDCardClusterCacheImpl(null));
        Bootstrap.start();
    }
        
    @Test
    public void test0() throws IOException, InterruptedException {       
        UserInfo userInfo = new UserInfo("1111111111", "given", "sur", "email", "occ", "role", "authcode");
        final IDCardCache cardCache = Factory.getIDCardCache();
        IDCardClusterCacheEntry cacheEntry = cardCache.ensureIDCard("minBruger");
        cardCache.updateEntryState(cacheEntry, IDCardState.NEW);
        cardCache.entryUpdatedLocally(cacheEntry);
        UserIDCard userIDCard = new UserIDCard("1.0.1", AuthenticationLevel.MOCES_TRUSTED_USER,"issuer", new SystemInfo(new CareProvider("medcom:skscode", "bar", "foobar"), "sosigwtest"), userInfo, null, null, null, null);
        
        cacheEntry.setIdCard(userIDCard);
        cardCache.updateEntryState(cacheEntry, IDCardState.AWAITING_BROWSER_RESPONSE);
        cardCache.entryUpdatedLocally(cacheEntry);
        cardCache.updateEntryState(cacheEntry, IDCardState.AWAITING_SIGNED_BYTES);
        cardCache.entryUpdatedLocally(cacheEntry);
        cardCache.updateEntryState(cacheEntry, IDCardState.AWAITING_STS_RESPONSE);
        cardCache.entryUpdatedLocally(cacheEntry);
        cardCache.updateEntryState(cacheEntry, IDCardState.REVOKED);
        cardCache.entryUpdatedLocally(cacheEntry);

        Thread.sleep(1500);
    }
}
