/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.spikes;

import java.io.IOException;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import com.trifork.sosigw.Bootstrap;
import com.trifork.sosigw.Factory;
import com.trifork.sosigw.auditlog.AuditLog;
import com.trifork.sosigw.cluster.IDCardClusterCacheImpl;
import com.trifork.sosigw.config.RuntimeConfig;
import com.trifork.sosigw.config.RuntimeConfigEditState;
import com.trifork.sosigw.config.RuntimeConfigState;

public class ConfClusterTest {
    
    @Before
    public void setup() {
        Factory.setTheIDCardCache(new IDCardClusterCacheImpl(null));
        if(AuditLog.isWorking()) {
            AuditLog.stop();
        }
        Bootstrap.start();
        
    }
    
    @Test
    public void test0() throws IOException, InterruptedException {
        Assert.assertNotNull( Factory.getIntercom());
        
        RuntimeConfigEditState editableVersion = RuntimeConfig.getRuntimeConfigState().getEditableVersion();
        editableVersion.addEntry(RuntimeConfig.CATEGORY_CLIENTACCESSWHITELIST, "Mortens." + System.currentTimeMillis(), new String[] { "10.", "mitSalt"} );

        RuntimeConfigState result = editableVersion.getResult();
        RuntimeConfig.setRuntimeConfigState(result);
        Factory.getIntercom().configUpdatedLocally();
        
        Thread.sleep(1500);

        Factory.getIntercom().configUpdatedLocally();
        Thread.sleep(1500);
    }
}
