/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.sts;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpSession;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

public class RequestStub implements HttpServletRequest {
	private String remoteAddr;

	public RequestStub(String remoteAddr) {
		super();
		this.remoteAddr = remoteAddr;
	}


	public String getHeader(String s) {
		return null;
	}

	public String getRemoteAddr() {
		return remoteAddr;
	}


	// Below this point methods from the interface are just implemented as throw new UnsupportedOperationException

	public String getAuthType() {
		throw new UnsupportedOperationException("getAuthType");
	}

	public Cookie[] getCookies() {
		throw new UnsupportedOperationException("getCookies");
	}

	public long getDateHeader(String s) {
		throw new UnsupportedOperationException("getDateHeader");
	}

	public Enumeration getHeaders(String s) {
		throw new UnsupportedOperationException("getHeaders");
	}

	public Enumeration getHeaderNames() {
		throw new UnsupportedOperationException("getHeaderNames");
	}

	public int getIntHeader(String s) {
		throw new UnsupportedOperationException("getIntHeader");
	}

	public String getMethod() {
		throw new UnsupportedOperationException("getMethod");
	}

	public String getPathInfo() {
		throw new UnsupportedOperationException("getPathInfo");
	}

	public String getPathTranslated() {
		throw new UnsupportedOperationException("getPathTranslated");
	}

	public String getContextPath() {
		throw new UnsupportedOperationException("getContextPath");
	}

	public String getQueryString() {
		throw new UnsupportedOperationException("getQueryString");
	}

	public String getRemoteUser() {
		throw new UnsupportedOperationException("getRemoteUser");
	}

	public boolean isUserInRole(String s) {
		throw new UnsupportedOperationException("isUserInRole");
	}

	public Principal getUserPrincipal() {
		throw new UnsupportedOperationException("getUserPrincipal");
	}

	public String getRequestedSessionId() {
		throw new UnsupportedOperationException("getRequestedSessionId");
	}

	public String getRequestURI() {
		throw new UnsupportedOperationException("getRequestURI");
	}

	public StringBuffer getRequestURL() {
		throw new UnsupportedOperationException("getRequestURL");
	}

	public String getServletPath() {
		throw new UnsupportedOperationException("getServletPath");
	}

	public HttpSession getSession(boolean b) {
		throw new UnsupportedOperationException("getSession");
	}

	public HttpSession getSession() {
		throw new UnsupportedOperationException("getSession");
	}

	public boolean isRequestedSessionIdValid() {
		throw new UnsupportedOperationException("isRequestedSessionIdValid");
	}

	public boolean isRequestedSessionIdFromCookie() {
		throw new UnsupportedOperationException("isRequestedSessionIdFromCookie");
	}

	public boolean isRequestedSessionIdFromURL() {
		throw new UnsupportedOperationException("isRequestedSessionIdFromURL");
	}

	public boolean isRequestedSessionIdFromUrl() {
		throw new UnsupportedOperationException("isRequestedSessionIdFromUrl");
	}

	public Object getAttribute(String s) {
		throw new UnsupportedOperationException("getAttribute");
	}

	public Enumeration getAttributeNames() {
		throw new UnsupportedOperationException("getAttributeNames");
	}

	public String getCharacterEncoding() {
		throw new UnsupportedOperationException("getCharacterEncoding");
	}

	public void setCharacterEncoding(String s) throws UnsupportedEncodingException {
		throw new UnsupportedOperationException("setCharacterEncoding");
	}

	public int getContentLength() {
		throw new UnsupportedOperationException("getContentLength");
	}

	public String getContentType() {
		throw new UnsupportedOperationException("getContentType");
	}

	public ServletInputStream getInputStream() throws IOException {
		throw new UnsupportedOperationException("getInputStream");
	}

	public String getParameter(String s) {
		throw new UnsupportedOperationException("getParameter");
	}

	public Enumeration getParameterNames() {
		throw new UnsupportedOperationException("getParameterNames");
	}

	public String[] getParameterValues(String s) {
		throw new UnsupportedOperationException("getParameterValues");
	}

	public Map getParameterMap() {
		throw new UnsupportedOperationException("getParameterMap");
	}

	public String getProtocol() {
		throw new UnsupportedOperationException("getProtocol");
	}

	public String getScheme() {
		throw new UnsupportedOperationException("getScheme");
	}

	public String getServerName() {
		throw new UnsupportedOperationException("getServerName");
	}

	public int getServerPort() {
		throw new UnsupportedOperationException("getServerPort");
	}

	public BufferedReader getReader() throws IOException {
		throw new UnsupportedOperationException("getReader");
	}

	public String getRemoteHost() {
		throw new UnsupportedOperationException("getRemoteHost");
	}

	public void setAttribute(String s, Object o) {
		throw new UnsupportedOperationException("setAttribute");
	}

	public void removeAttribute(String s) {
		throw new UnsupportedOperationException("removeAttribute");
	}

	public Locale getLocale() {
		throw new UnsupportedOperationException("getLocale");
	}

	public Enumeration getLocales() {
		throw new UnsupportedOperationException("getLocales");
	}

	public boolean isSecure() {
		throw new UnsupportedOperationException("isSecure");
	}

	public RequestDispatcher getRequestDispatcher(String s) {
		throw new UnsupportedOperationException("getRequestDispatcher");
	}

	public String getRealPath(String s) {
		throw new UnsupportedOperationException("getRealPath");
	}

	public int getRemotePort() {
		throw new UnsupportedOperationException("getRemotePort");
	}

	public String getLocalName() {
		throw new UnsupportedOperationException("getLocalName");
	}

	public String getLocalAddr() {
		throw new UnsupportedOperationException("getLocalAddr");
	}

	public int getLocalPort() {
		throw new UnsupportedOperationException("getLocalPort");
	}
}
