/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.testclient;

import java.net.MalformedURLException;

import javax.xml.bind.JAXBException;

import com.trifork.sosigw.test.DoInvokeExceptionResponse;

import dk.medcom.dgws._2006._04.dgws_1_0.Header;

public class TestClient {
    private static final String DCC_HOST = System.getProperty("dcc.host", "localhost");

    public static void main(String[] args) throws JAXBException, DoInvokeExceptionResponse, MalformedURLException {
        int responsePayloadSize = 10;

        System.out.println("Test Client, payload size: " + responsePayloadSize);
        String requestPayload = "small payload";
        
        ServiceStubClient client = new ServiceStubClient("172.16.175.130");

        //String endpoint = "http://172.16.175.130:8080/sosigw/proxy/soap-request";
        String endpoint = "http://"+DCC_HOST+":8181/sosigw-testservice/stubservice/doInvoke";
        
        
        String result = client.doInvoke(null, null, requestPayload, responsePayloadSize, 0, endpoint, false);
        
        System.out.println("Got: " + (result == null ? null : result.length()) + " bytes");
        System.out.println(result);
        
    }

}
