/*
* The MIT License
*
* Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of
* this software and associated documentation files (the "Software"), to deal in
* the Software without restriction, including without limitation the rights to
* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
* of the Software, and to permit persons to whom the Software is furnished to do
* so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* $HeadURL$
* $Id$
*/
package com.trifork.sosigw.testserver;

import javax.jws.WebService;

import org.oasis_open.docs.wss._2004._01.oasis_200401_wss_wssecurity_secext_1_0.Security;

import com.trifork.sosigw.test.DoInvokeExceptionResponse;
import com.trifork.sosigw.test.DoInvokeParamType;
import com.trifork.sosigw.test.StubType;

import dk.medcom.dgws._2006._04.dgws_1_0.Header;




@WebService(endpointInterface = "com.trifork.sosigw.test.StubType")
public class StubServiceImpl implements StubType {

    private static char[] resultBuffer = new char[0];
    
    public String doInvoke(Security wsseHeader, Header medcomHeader, DoInvokeParamType requestPayloadBody)
            throws DoInvokeExceptionResponse {
        
        int delay = requestPayloadBody.getServiceDelay();
        int payloadSizeParam = requestPayloadBody.getRequestPayloadSizeParam();
        System.out.println("doInvoke (payload was " + requestPayloadBody.getRequestPayloadParam().length() + " chars) delay=" + delay + " reponseSize=" + payloadSizeParam);

        if (delay > 0) {
            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {
            }
        }
        
        char[] resultPayload;
        if (resultBuffer.length < payloadSizeParam) {
            resultPayload = new char[payloadSizeParam];
            for (int i = 0; i < resultPayload.length; i++) {
                resultPayload[i] = '#';
            }
            resultBuffer = resultPayload;
        } else {
            resultPayload = resultBuffer;
        }
        
        return new String(resultPayload, 0, payloadSizeParam);
    }
}

    
