CREATE SCHEMA sosigwlog AUTHORIZATION DBA

CREATE SEQUENCE sosigwlog.PKSEQ

CREATE TABLE sosigwlog.SOSIGWLOG (lpk bigint PRIMARY KEY,  systemid varchar(64) NOT NULL, operation varchar(32) NOT NULL,  cpr varchar(10) NOT NULL,  moment timestamp NOT NULL, wsato varchar(512), wsaaction varchar(512), clientip varchar(40))

CREATE TABLE sosigwlog.RUNTIMECONFIG (configpk bigint PRIMARY KEY, moment timestamp NOT NULL, CONSTRAINT runtimeconfig_moment_key UNIQUE(moment))

CREATE TABLE sosigwlog.RUNTIMECONFIG_ELM (elmpk bigint PRIMARY KEY, configpk bigint NOT NULL, category varchar(64) NOT NULL, elmkey varchar(64) NOT NULL, valuecount int NOT NULL)

CREATE TABLE sosigwlog.RUNTIMECONFIG_DATA (datapk bigint PRIMARY KEY, elmpk bigint NOT NULL, idx int NOT NULL, value varchar(1000))

CREATE SEQUENCE sosigwlog.RUNTIMECONFIG_PKSEQ

CREATE INDEX configpk_idx ON sosigwlog.RUNTIMECONFIG_ELM(configpk)
CREATE INDEX elmpk_idx ON sosigwlog.RUNTIMECONFIG_DATA(elmpk)



CREATE SCHEMA sosigwgloballog AUTHORIZATION DBA
CREATE SEQUENCE sosigwgloballog.PKSEQ
CREATE SEQUENCE sosigwgloballog.STATICPKSEQ

CREATE TABLE sosigwgloballog.sosigwgloballog (pk bigint PRIMARY KEY, systemid int NOT NULL, operation int NOT NULL, cpr varchar(10) NOT NULL, moment timestamp NOT NULL, wsa int, clientip int)

CREATE TABLE sosigwgloballog.systemid (pk int PRIMARY KEY, systemid varchar(64) NOT NULL)

CREATE TABLE sosigwgloballog.clientip (pk int PRIMARY KEY, clientip varchar(40) NOT NULL)

CREATE TABLE sosigwgloballog.wsa (pk int PRIMARY KEY, wsato varchar(512), wsaaction varchar(512))

CREATE TABLE sosigwgloballog.operation (pk int PRIMARY KEY, operation varchar(32) NOT NULL)


CREATE ALIAS NEXTVAL FOR "com.trifork.sosigw.auditlog.SqlTests.nextval"